const ProtocolAction = require('./_base-action.js');

/**
 * Retrieve or delete all cookies visible to the current page or set a cookie. Normally this shouldn't be used directly, instead the cookie convenience methods should be used: <code>getCookie</code>, <code>getCookies</code>, <code>setCookie</code>, <code>deleteCookie</code>, <code>deleteCookies</code>.
 *
 * @link /#cookies
 * @param {string} method Http method
 * @param {function|object} [callbackOrCookie] Optional callback function to be called when the command finishes.
 * @see getCookies
 * @see getCookie
 * @see setCookie
 * @see deleteCookie
 * @see deleteCookies
 * @api protocol.cookies
 */
module.exports = class Debugger extends ProtocolAction {
  async command(element) {
    const {encode} = require('html-entities');
    const {openNewWindow, navigateTo, getElementProperty, locateMultipleElements, executeScript} = this.transportActions;
    // await this.api.executeScript(function() {
    //   debugger;
    // });

    /*
    let htmlTag;
    try {
      //const elements = await locateMultipleElements(element);
      const elements = await locateMultipleElements('form[method=get]');
      const webElement = elements.value[0];
      const elementKey = Object.keys(webElement);
      const elementId = webElement[elementKey];
      const outerHtml = await getElementProperty(elementId, 'outerHTML');
      htmlTag = outerHtml.value.split(/(<.+>)/).slice(1)[0];
      console.log('outer', htmlTag);
    } catch (err) {
      throw new Error('Error while trying to locate element: ' + element + '\n' + err.stack);
    }

    await openNewWindow('window');

    await navigateTo('http://' + this.api.capabilities['goog:chromeOptions'].debuggerAddress);
    await this.api.click('a.item:nth-child(2)');
    await this.api.pause(2000);

    const script = function(selector) {
      var shadowRoot = document.querySelectorAll('#elements-content div')[0].shadowRoot;

      return shadowRoot.querySelectorAll(selector);
    };

    // const fn = 'var passedArgs = Array.prototype.slice.call(arguments,0); return (' +
    //   script.toString() + ').apply(window, passedArgs);';
    // const shadowRootElement = await this.api.execute(script, '.webkit-html-tag[aria-label="'+ encode(htmlTag) +'"]');
    const shadowRootElement = await this.api.execute(script, '.webkit-html-tag[aria-label]');
    */

    await openNewWindow('window');

    await navigateTo('http://' + this.api.capabilities['goog:chromeOptions'].debuggerAddress);
    await this.api.click('a.item:nth-child(2)');
    await this.api.pause(5000);

    const script = function(selector) {
      var element = document.querySelector(selector);
      console.log(selector, element);
      return element;
    };

    await this.api.switchToMainWindow();

    //await this.api.pause(5000);

    await this.api.execute(script, element);

    await this.api.pause();

    // <span class="webkit-html-tag" classNamelabel="<form method=&ZeroWidthSpace;&quot;get&quot;>">&lt;<span
    //   class="webkit-html-tag-nclassNameform</span> <span class=" webkit-html-attriclassName><span
    //   class="webkit-html-attriclassNamename">method</span>=&ZeroWidthSpace;"<span
    //   class="webkit-html-attriclassNamevalue">get</span>"</span>&gt;</span>
    //console.log('shadowRoot', shadowRootElement)

    const elementToInspect = '.webkit-html-tag[aria-label="'+ encode(htmlTag) +'"]';
    console.log('elementToInspect', elementToInspect)
    // await this.api.click(elementToInspect);
    //aria-label="<section id="releases-container" data-page-uri="/releases" class="secondary">"
    // <span class="webkit-html-tag" aria-label="<p class=​&quot;align-left&quot;>">&lt;<span class="webkit-html-tag-name">p</span> <span class="webkit-html-attribute"><span class="webkit-html-attribute-name">class</span>=​"<span class="webkit-html-attribute-value">align-left</span>"</span>&gt;</span>



    // await this.api.perform(function() {
    //   const actions = this.actions();
    //
    //   //return actions.contextClick();
    //   return actions
    //     .keyDown(this.Keys.META)
    //     .keyDown(this.Keys.ALT)
    //     .keyDown('c')
    //     .keyUp('c')
    //     .keyUp(this.Keys.ALT)
    //     .keyUp(this.Keys.META)
    // });

    await this.api.pause();

    if (element) {
      await this.api.moveToElement(element, 10, 10, function(result) {
        console.log('RESULT', result)

        return result;
      });
    }

    await this.api.perform(function() {
      const actions = this.actions({bridge: true});

      return actions.contextClick();
    });

    await this.api.pause(1000)
      .perform(function() {
        const actions = this.actions({bridge: true});

        return actions.sendKeys('i')
          //.sendKeys(this.Keys.ARROW_UP)
      });

    //.pause(200).sendKeys(this.Keys.ARROW_UP).sendKeys(this.Keys.RETURN)

    await this.api.pause();

  }
};
